﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel

Public Class Ticker : Implements INotifyPropertyChanged
    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
    Private Sub OnPropertyChanged(ByVal info As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(info))
    End Sub

    Public Property Name As String
    Public Property Minutes As New ObservableCollection(Of Minute)
    Public Property Days As New ObservableCollection(Of Day)
    Public Property TotalDays As Integer
    Public Property OpenTime As TimeSpan
    Public Property CloseTime As TimeSpan
    Public Property Holidays As New List(Of Date)
    Public Property StartPrice As Double
    Public Property StartDay As Date

End Class

Public Class Day
    Public Property Minutes As New ObservableCollection(Of Minute)
End Class

Public Class Minute : Implements INotifyPropertyChanged
    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
    Private Sub OnPropertyChanged(ByVal info As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(info))
    End Sub

    Public Property Ticker As Ticker
    Public Property DateTime As DateTime

    Public Property Open As Double = Double.NaN
    Public Property High As Double = Double.NaN
    Public Property Low As Double = Double.NaN
    Public Property Close As Double = Double.NaN

    Public Property Zero As Double = 0

    Private _Price As Double = Double.NaN
    Public Property Price As Double
        Get
            Return _Price
        End Get
        Set(value As Double)
            _Price = value
            OnPropertyChanged("Price")
        End Set
    End Property

    Private _Price2 As Double = Double.NaN
    Public Property Price2 As Double
        Get
            Return _Price2
        End Get
        Set(value As Double)
            _Price2 = value
            OnPropertyChanged("Price2")
        End Set
    End Property

    Private _Volume1 As Double = Double.NaN
    Public Property Volume1 As Double
        Get
            Return _Volume1
        End Get
        Set(value As Double)
            _Volume1 = value
            OnPropertyChanged("Volume1")
        End Set
    End Property

    Private _Volume2 As Double = Double.NaN
    Public Property Volume2 As Double
        Get
            Return _Volume2
        End Get
        Set(value As Double)
            _Volume2 = value
            OnPropertyChanged("Volume2")
        End Set
    End Property

End Class
