﻿Imports System.Collections.ObjectModel

Public Class ViewModel

    Public Property Tickers As New ObservableCollection(Of ticker)
    Public RandomGenerator As New Random


    Sub New()

        Dim newTicker As New Ticker
        newTicker.Name = "A"
        newTicker.TotalDays = 100
        newTicker.StartPrice = 100
        newTicker.StartDay = DateTime.Parse("01/05/2017")
        newTicker.OpenTime = New TimeSpan(9, 0, 0)
        newTicker.CloseTime = New TimeSpan(16, 0, 0)
        newTicker.Holidays.Add(New Date(2000, 1, 11))
        newTicker.Holidays.Add(New Date(2000, 1, 20))
        newTicker.Holidays.Add(New Date(2000, 1, 25))
        Tickers.Add(newTicker)
        AddMinutes(newTicker)
        AddEmptyDay(newTicker)

    End Sub

    Sub AddMinutes(inTicker As Ticker)
        Dim price As Double
        Dim currentDay As DateTime = inTicker.StartDay
        Dim countDays As Integer = 0

        Do

            If currentDay.DayOfWeek <> DayOfWeek.Saturday And currentDay.DayOfWeek <> DayOfWeek.Sunday Then

                Dim IsHoliday As Boolean = False
                For Each holiday In inTicker.Holidays
                    If currentDay = holiday Then
                        IsHoliday = True
                        Exit For
                    End If
                Next

                If IsHoliday = False Then

                    Dim MinuteSpan As TimeSpan = inTicker.OpenTime
                    price = inTicker.StartPrice

                    Dim newDay As New Day
                    inTicker.Days.Add(newDay)

                    Do 'create minutes for this day
                        Dim ChangeDirection As Integer = GetRandomInteger(0, 1)
                        Dim Change As Double = GetRandomDouble(5)
                        Select Case ChangeDirection
                            Case 0
                                Change = Change
                            Case 1
                                Change = -Change
                        End Select

                        price = price * ((Change / 100) + 1)

                        Dim newMinute As New Minute
                        newMinute.Ticker = inTicker
                        newMinute.DateTime = currentDay.Add(MinuteSpan)
                        newMinute.Open = price
                        newMinute.High = price
                        newMinute.Low = price
                        newMinute.Close = price
                        newMinute.Price = price
                        newMinute.Price2 = price * 1.1

                        newMinute.Volume1 = 200 + GetRandomInteger(0, 50)
                        newMinute.Volume2 = 25 + GetRandomInteger(0, 50)

                        inTicker.Minutes.Add(newMinute)
                        inTicker.Days.Last.Minutes.Add(newMinute)

                        MinuteSpan = MinuteSpan.Add(TimeSpan.FromMinutes(1))

                    Loop Until MinuteSpan > inTicker.CloseTime

                    countDays += 1

                End If

            End If

            currentDay = currentDay.AddDays(1)

        Loop Until countDays >= inTicker.TotalDays

    End Sub

    Sub AddEmptyDay(inTicker As Ticker)

        Dim currentDay As DateTime = inTicker.Minutes.Last.DateTime.Date.AddDays(1)
        Dim MinuteSpan As TimeSpan = inTicker.OpenTime

        inTicker.Days.Add(New Day)

        Do
            Dim newMinute As New Minute
            newMinute.Ticker = inTicker
            newMinute.DateTime = currentDay.Add(MinuteSpan)

            inTicker.Minutes.Add(newMinute)
            inTicker.Days.Last.Minutes.Add(newMinute)

            MinuteSpan = MinuteSpan.Add(TimeSpan.FromMinutes(1))

        Loop Until MinuteSpan > inTicker.CloseTime

    End Sub

    Public Function GetRandomInteger(ByVal Min As Integer, ByVal Max As Integer) As Integer
        Return RandomGenerator.Next(Min, Max + 1)
    End Function

    Public Function GetRandomDouble(ByVal Max As Integer) As Double
        Return RandomGenerator.NextDouble() * Max
    End Function


End Class
